# Sujet de TP 1: Gitlab, Benchmarks et tableaux dynamiques

## Exercice 1: Lancer les benchmarks

Nous allons tester différentes implémentations des tableaux dynamiques dans différents langages.

Lisez les fichiers `main` de chaque langage et vérifiez que la même expérience est bien effectuée à chaque fois.

Exécutez le script `SHELL` (le lire ne vous fera pas de mal non plus):

`sh launch_analysis.sh`

Une fois les calculs effectués, regardez les fichiers `pdf` obtenus dans le répertoire `plots`

## Exercice 2: A vous de jouer!

Dans le langage de votre choix (C, C++, JAVA, pas possible en Python), modifiez la fonction `enlarge_capacity` 
afin de multiplier la capacité du tableaux par une autre constante `alpha` que 2 (Demandez à votre chargé de TP 
de choisir une constante alpha pour votre binôme).

Dans la fonction `main`, changez le nom de fichiers de sortie en ramplaçant `alpha_2` par `alpha_votre_valeur`

Dans le répertoire `plots`, faites une copie du fichier `plot_result`

`cp plot_result my_plot_result`

Modifiez le fichier `my_plot_result` pour ne fournir que des courbes dans le langage que vous avez choisi.
Modifiez également le nom des fichiers pdf en sortie afin qu'ils contiennent la bonne valeur de alpha.

Modifiez le fichier `launch_analysis.sh` afin qu'il exécute gnuplot à partir de `my_plot_result`

Relancez le script `launch_analysis.sh`

## Exercice 3: Au rapport!

Créez un fichier RAPPORT.md à la racine projet.

1) Tentez d'expliquer pourquoi certains langages sont plus rapides que d'autres dans cette expérience.

2) Observez l'espace mémoire inutilisé au fur et à mesure du programme. Qu'en pensez vous? 
Imaginez un scénario dans lequel cela pourrait poser problème.

3) Décrivez les différences obtenues en faisant varier alpha dans les deux expériences.
